package com.gic.cloud.constants;
/**
 * 功能权限集
 * @ClassName: FunctionEnum 
 * @Description:  
 * @author guojuxing 
 * @date 2020/7/7 4:15 PM 
 */
public enum FunctionEnum {
    RANK_LIST("FUC001", "排行榜"),
    MEMBER_PROFILE("FUC002", "会员概况"),
    RECRUITMENT_ANALYSIS("FUC003", "招募分析"),
    MEMBER_PORTRAIT("FUC004", "会员画像"),
    PERFORMANCE_OVERVIEW("FUC005", "业绩概览"),
    CONSUME_COMPOSITION("FUC006", "消费构成"),
    ITEM_RANK("FUC007", "单品排行"),
    BASIC_PERFORMANCE("FUC008", "基础业绩"),
    MEMBER_DISTRIBUTION("FUC009", "会员分布");

    private String code;
    private String name;

    private FunctionEnum(String code, String name) {
        this.code = code;
        this.name = name;
    }

    public static boolean isRightCode(String code) {
        for (FunctionEnum functionEnum : values()) {
            if (functionEnum.getCode().equals(code)) {
                return true;
            }
        }
        return false;
    }

    public String getCode() {
        return code;
    }

    public FunctionEnum setCode(String code) {
        this.code = code;
        return this;
    }

    public String getName() {
        return name;
    }

    public FunctionEnum setName(String name) {
        this.name = name;
        return this;
    }
}
