package com.gic.cloud.dao.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.gic.cloud.dto.EnterprisePortraitRelDTO;
import com.gic.cloud.entity.TabGicEnterprisePortraitRel;

public interface EnterprisePortraitRelMapper {
    /**
     * 根据主键删除
     *
     * @param portraitRelationId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer portraitRelationId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabGicEnterprisePortraitRel record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabGicEnterprisePortraitRel record);

    /**
     * 根据主键查询
     *
     * @param portraitRelationId 主键
     * @return 实体对象
     */
    TabGicEnterprisePortraitRel selectByPrimaryKey(Integer portraitRelationId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabGicEnterprisePortraitRel record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabGicEnterprisePortraitRel record);

    /**
     * 查询会员画像字段列表
     * @Title: listPortraitField 
     * @Description:
     * @author guojuxing
     * @param enterpriseId 
     * @return  java.util.List<com.gic.cloud.entity.TabGicEnterprisePortraitRel> 
     */
    List<TabGicEnterprisePortraitRel> listPortraitField(@Param("enterpriseId") Integer enterpriseId,
                                                        @Param("dataType") Integer dataType,
                                                        @Param("status") Integer status);

    /**
     * 批量插入
     * @Title: insertForeach 
     * @Description:
      * @author guojuxing
     * @param list 
     * @return  void 
      */
    void insertForeach(@Param("list") List<EnterprisePortraitRelDTO> list);

    TabGicEnterprisePortraitRel getPortraitField(@Param("enterpriseId") Integer enterpriseId,
                           @Param("fieldCode") String fieldCode,
                           @Param("dataType") Integer dataType);

    int getMaxSort(@Param("enterpriseId") Integer enterpriseId, @Param("dataType") Integer dataType);

    List<TabGicEnterprisePortraitRel> listByDataType(@Param("enterpriseId") Integer enterpriseId, @Param("dataType") Integer dataType);
}