package com.gic.cloud.dao.mapper;

import com.gic.cloud.entity.TabIndexDescEnterprise;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface TabIndexDescEnterpriseMapper {
    /**
     * 根据主键删除
     *
     * @param indexDescEnterpriseId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer indexDescEnterpriseId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabIndexDescEnterprise record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabIndexDescEnterprise record);

    /**
     * 根据主键查询
     *
     * @param indexDescEnterpriseId 主键
     * @return 实体对象
     */
    TabIndexDescEnterprise selectByPrimaryKey(Integer indexDescEnterpriseId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabIndexDescEnterprise record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabIndexDescEnterprise record);

    void updateSort(@Param("enterpriseId") Integer enterpriseId, @Param("sort") Integer sort);

    void deleteList(@Param("ids") List<Integer> deleteList);
}