package com.gic.cloud.dao.mapper;

import com.gic.cloud.dto.IndexDescDTO;
import com.gic.cloud.entity.TabIndexDesc;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface TabIndexDescMapper {
    /**
     * 根据主键删除
     *
     * @param indexDescId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer indexDescId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabIndexDesc record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabIndexDesc record);

    /**
     * 根据主键查询
     *
     * @param indexDescId 主键
     * @return 实体对象
     */
    TabIndexDesc selectByPrimaryKey(Integer indexDescId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabIndexDesc record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabIndexDesc record);

    List<IndexDescDTO> listByEnterpriseAndModule(@Param("enterpriseId") Integer enterpriseId, @Param("moduleId") String moduleId, @Param("indexGroupName") String indexGroupName);

    List<IndexDescDTO> listByEnterpriseAndModuleDetail(@Param("enterpriseId") Integer enterpriseId, @Param("moduleId") String moduleId, @Param("indexGroupName") String indexGroupName, @Param("userId") Integer userId, @Param("indexStatus") Integer indexStatus);

//    List<IndexDescDTO> listRecycle(@Param("enterpriseId") Integer enterpriseId, @Param("moduleId") String moduleId, @Param("indexGroupName") String indexGroupName, @Param("userId") Integer userId);

    List<TabIndexDesc> listAll();

    List<TabIndexDesc> listAllUnRel(@Param("ids") List<Integer> relIndexDescIdList);

    List<TabIndexDesc> listByIds(@Param("ids") List<Integer> indexDescIdList);

    TabIndexDesc getIndexDescByIndexCode(@Param("moduleId") String moduleId, @Param("indexCode") String indexCode, @Param("indexGroupName") String indexGroupName);
}