package com.gic.cloud.web.utils;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;
import org.apache.commons.lang3.StringUtils;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class StringJsonSeralizer extends JsonSerializer<String> {

    @Override
    public void serialize(String value, JsonGenerator jsonGenerator, SerializerProvider serializerProvider) throws IOException, JsonProcessingException {
        if(StringUtils.isNotBlank(value)){
            Pattern pattern = Pattern.compile("\\d+\\.\\d+$|-\\d+\\.\\d+$");
            Matcher isNum = pattern.matcher(value);
            if(isNum.matches()){
                BigDecimal decimal = new BigDecimal(value).setScale(2, BigDecimal.ROUND_HALF_UP);
                jsonGenerator.writeString(decimal.toString());
                return;
            }
        }
        jsonGenerator.writeString(value);
    }
}

